// Coast Client
// Arduino 1.6.5

#include <ESP8266WiFi.h>

char ssid[] = "SHIP";            // SSID of your home WiFi
char pass[] = "xxxxxxxxxxxx";  // password of your home WiFi

IPAddress server(10, 10, 10, 10); // 10.10.10.10 IP address of the SHIP

WiFiClient client;

void setup() {

  pinMode(D0, OUTPUT);
  pinMode(D3, OUTPUT);
  pinMode(D4, OUTPUT);
  pinMode(D7, OUTPUT);
  pinMode(D8, OUTPUT);

  digitalWrite(D0, HIGH);
  digitalWrite(D3, HIGH);
  digitalWrite(D4, HIGH);
  digitalWrite(D7, HIGH);
  digitalWrite(D8, HIGH);

  pinMode(D1, INPUT_PULLUP);
  pinMode(D2, INPUT_PULLUP);
  pinMode(D5, INPUT_PULLUP);
  pinMode(D6, INPUT_PULLUP);

  Serial.begin(115200);               // only for debug

  WiFi.begin(ssid, pass);             // connects to the WiFi router

  while (WiFi.status() != WL_CONNECTED) {
    wait_server(1);
    delay(250);
    wait_server(0);
    delay(250);
  }

  all_off();

}

void loop () {

  if (digitalRead(D1) == 0) { // Turn ON D1
    all_on();
    digitalWrite(D3, HIGH);
    client.connect(server, 80);
    client.println("LL\r");
    String answer = client.readStringUntil('\r');
    client.flush();
    digitalWrite(D3, LOW);
    all_off();
  }

  if (digitalRead(D2) == 0) { // Turn ON D2
    all_on();
    digitalWrite(D4, HIGH);
    client.connect(server, 80);
    client.println("RR\r");
    String answer = client.readStringUntil('\r');
    client.flush();
    all_off();
    digitalWrite(D4, LOW);

  }

  if (digitalRead(D5) == 0) { // Turn ON D5
    all_on();
    digitalWrite(D7, HIGH);
    client.connect(server, 80);
    client.println("AA\r");
    String answer = client.readStringUntil('\r');
    client.flush();
    digitalWrite(D7, LOW);
    all_off();
  }
  
  if (digitalRead(D6) == 0) { // Turn ON D6
    all_on();
    digitalWrite(D8, HIGH);
    client.connect(server, 80);
    client.println("BB\r");
    String answer = client.readStringUntil('\r');
    client.flush();
    all_off();
    digitalWrite(D8, LOW);
  }

}

void all_on() {
  digitalWrite(D0, HIGH);
}

void all_off() {
  digitalWrite(D0, LOW);
  digitalWrite(D3, LOW);
  digitalWrite(D4, LOW);
  digitalWrite(D7, LOW);
  digitalWrite(D8, LOW);
}

void wait_server(byte leds) {
  if (leds == 1) {
    digitalWrite(D0, LOW);
    digitalWrite(D3, HIGH);
    digitalWrite(D4, LOW);
    digitalWrite(D7, HIGH);
    digitalWrite(D8, LOW);
  } else {
    digitalWrite(D0, HIGH);
    digitalWrite(D3, LOW);
    digitalWrite(D4, HIGH);
    digitalWrite(D7, LOW);
    digitalWrite(D8, HIGH);
  }

}


